//-----------------------------------------------------------------------------
// FILE:              JavaListener.h
//
//    Copyright (C)  2000 SoftTrac Corporation. All rights reserved.
//-----------------------------------------------------------------------------
// %W% %G%
#ifndef SoftTrac_JavaListener_H
#define SoftTrac_JavaListener_H

#include <map>
#include "jni/JavaMessage.h"
#include "util/Observer.h"

namespace SoftTrac {

class JavaObject;

//-----------------------------------------------------------------------------
// CLASS: JavaListener
//-----------------------------------------------------------------------------
class JavaListener : public JavaMessage,
                     public Observer
{
public:
   virtual ~JavaListener();

   static JavaListener* listener(const std::string& listenerName);

   virtual void update(Event*) = 0;

   virtual std::string name() const { return theNativeClassName; }

protected:
   JavaListener(const std::string& nativeListenerName);

   void forwardNotify(); 

private:
   jobject theEvent;

public:
   void setEvent(jobject);
   void clearEvent();
};

} // namespace SoftTrac


#endif


