//-----------------------------------------------------------------------------
// FILE:              NativeListener.java
//
//    Copyright (C)  2000 SoftTrac Corporation. All rights reserved.
//-----------------------------------------------------------------------------

package com.softtrac.jni;

import java.util.*;

/**
 * The NativeListener interface is for any class that wants to listen
 * for events generated from a native subject.
 *
 * @author Timothy R. Culp
 * @version %W% %G%
 */
public interface NativeListener extends EventListener {
   //>
   /**
    * The nativeUpdate method is the method that will get invoked
    * by a native subjects. Arguments can be retrieved from the
    * NativeCommand using various get methods.
    */
   //<
   public void   update(NativeEvent event) throws NativeMessage.Exception;
   public String nativeProxy();
   public int    eventNo();
}
