//-----------------------------------------------------------------------------
// FILE:              Battery.cpp
//
//    Copyright (C)  2000 SoftTrac Corporation. All rights reserved.
//-----------------------------------------------------------------------------
// %W% %G%

#include "tconfig.h"
#include "Battery.h"
#include "util/ttime.h"

namespace SoftTrac {

   
//-----------------------------------------------------------------------------
// Battery::Battery
//-----------------------------------------------------------------------------
Battery::Battery(int power) 
   : 
      theEvents       (this, "Battery", NUM_EVENTS), 
      theStartPower   (power),
      theCurrentPower (power)
{
}


//-----------------------------------------------------------------------------
// Battery::drawPower
//-----------------------------------------------------------------------------
void Battery::drawPower(int amount)
{
   if (theCurrentPower)
   {
      if (theCurrentPower == 100) theEvents.notify(FULL_POWER);
      
      theCurrentPower = (theCurrentPower>=amount) ? theCurrentPower-amount : 0;
      theEvents.notify(POWER_CHANGE);
      
      if (theCurrentPower && (double)theCurrentPower/theStartPower <= .2) 
      {
         theEvents.notify(LOW_POWER);
      }
      else if (!theCurrentPower) theEvents.notify(NO_POWER);
   }
   else theEvents.notify(NO_POWER);
}


} // namespace SoftTrac

