package com.softtrac.jni.example;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.softtrac.jni.*;

public class BatteryController extends JFrame
{
   public BatteryController() throws NativeInterface.Exception {
      super("BatteryController");

      //---
      // Create the Battery and attach some listeners
      //---
      theBattery = new Battery();
      theBattery.addNativeListener(new FullPowerListener());
      theBattery.addNativeListener(new PowerChangeListener());
      theBattery.addNativeListener(new LowPowerListener());
      theBattery.addNativeListener(new NoPowerListener());
   }

   class FullPowerListener implements NativeListener {
      public void update(NativeEvent event) {
         //---
         // Get any return arguments
         //---
         // int value1 = getInt("keyword1");
         // double value2 = getDouble("keyword2");
      }

      public String name() {
         return "BatteryController.FullPowerListener";
      }

      public int eventNo() {
         //>
         return Battery.FullPower;
      } //<
   }

   class PowerChangeListener implements NativeListener {
      public void update(NativeEvent event) {
         //---
         // Get any return arguments
         //---
         // int value1 = getInt("keyword1");
         // double value2 = getDouble("keyword2");
      }

      public String name() {
         return "BatteryController.PowerChangeListener";
      }

      public int eventNo() {
         return Battery.PowerChange;
      }
   }

   class LowPowerListener implements NativeListener {
      public void update(NativeEvent event) {
         //---
         // Get any return arguments
         //---
         // int value1 = getInt("keyword1");
         // double value2 = getDouble("keyword2");
      }

      public String name() {
         return "BatteryController.LowPowerListener";
      }

      public int eventNo() {
         return Battery.LowPower;
      }
   }

   class NoPowerListener implements NativeListener {
      public void update(NativeEvent event) {
         //---
         // Get any return arguments
         //---
         // int value1 = getInt("keyword1");
         // double value2 = getDouble("keyword2");
      }

      public String name() {
         return "BatteryController.NoPowerListener";
      }

      public int eventNo() {
         return Battery.NoPower;
      }
   }

   public static void main(String[] args) {
      JFrame frame = new BatteryController();

      frame.addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            System.exit(0);
         }
      });

      frame.pack();
      frame.setVisible(true);
   }

   private Battery theBattery;
}
