#ifndef SoftTrac_ComputerPlayerServer_h
#define SoftTrac_ComputerPlayerServer_h

#include "ComputerPlayer.h"
#include "jni/JavaCommand.h"
#include "jni/JavaEvent.h"
#include "jni/JavaListener.h"

namespace SoftTrac {

class Event;

//-----------------------------------------------------------------------------
// CLASS: ComputerPlayerServer
//-----------------------------------------------------------------------------
class ComputerPlayerServer
{
public:
   static ComputerPlayer* subject();

   //---
   // Remote commands
   //---
   class ConstructCommand : public JavaCommand
   {
   public:
      ConstructCommand(const std::string& cmd);
      virtual void realExecute();
   };

   class NextMoveCommand : public JavaCommand
   {
   public:
      NextMoveCommand(const std::string& cmd);
      virtual void realExecute();
   };

   //---
   // Remote events/listeners
   //---
   class NewLookAheadEvent : public JavaEvent
   {
   public:
      NewLookAheadEvent(const std::string& event);
      virtual void attach(JavaListener* listener);
      virtual void detach(JavaListener* listener);
   };

   class NewLookAheadListener : public JavaListener
   {
   public:
      NewLookAheadListener(const std::string& listener);
      virtual void update(Event* event) throw(std::invalid_argument);
   };

private:
  static ComputerPlayer* theComputerPlayer;
};

} // namespace SoftTrac

#endif
