package com.softtrac.nomess;

import java.awt.*;
import java.awt.event.*;
import com.softtrac.jni.*;
import com.softtrac.util.Trace;


public class NoMess extends Frame
{
   public NoMess(int boardSize) throws NativeMessage.Exception {
      //>
      super("NoMess");
      final String METHOD = "NoMess";
      trace.enter(METHOD);
      
      theBoardCtrl = new BoardController(this, boardSize);
      theComputerCtrl = new ComputerPlayerController(theBoardCtrl);
      
      trace.exit(METHOD);
   } //<

   public static void main(String[] args) {
      //>
      try {
	  Integer boardSize = new Integer(args[0]);
	  Frame frame = new NoMess(boardSize.intValue());
	  
	  frame.addWindowListener(new WindowAdapter() {
		  public void windowClosing(WindowEvent e) {
		      System.exit(0);
		  }
	      });
	  
         frame.pack();
         frame.setVisible(true);
      }
      catch (Exception e) {
         System.err.println(e.getMessage());
      }
   } //<
    
   private BoardController          theBoardCtrl;
   private ComputerPlayerController theComputerCtrl;

   private static Trace trace;
   static {
      //>
      trace = new Trace("nomess.NoMess");
      // trace.setAll();
   } //<
}
