//----------------------------------------------------------------- 
// FILE: Square.h
//----------------------------------------------------------------- 
#ifndef Square_h
#define Square_h

#include <cmath>
#include <iosfwd>

namespace SoftTrac {


//----------------------------------------------------------------- 
// CLASS: Square
//----------------------------------------------------------------- 
class Square
{
public:
   Square(int row=-1, int col=-1) : theRow(row), theCol(col) {}
   Square(const int* ia) : theRow(ia[0]), theCol(ia[1]) {}
   
   int  row() const { return theRow; }
   int& row()       { return theRow; }
   
   int  col() const { return theCol; }
   int& col()       { return theCol; }
   
   bool operator==(const Square& s) const;
   bool operator!=(const Square& s) const { return !(*this==s); }
   bool operator!() const;
   
   double distanceTo(const Square& s) const;

private:
   int theRow;
   int theCol;
};


std::ostream& operator<<(std::ostream&, const Square&);


//----------------------------------------------------------------- 
// Square::operator==
//----------------------------------------------------------------- 
inline bool Square::operator==(const Square& s) const 
{ 
   return theRow == s.theRow && theCol == s.theCol; 
}


//----------------------------------------------------------------- 
// Square::distanceTo
//----------------------------------------------------------------- 
inline double Square::distanceTo(const Square& s) const
{ 
   return hypot(theRow-s.theRow, theCol-s.theCol); 
}


} // namespace SoftTrac

#endif
