//----------------------------------------------------------------- 
// FILE: Token.h
//----------------------------------------------------------------- 
#ifndef Token_h
#define Token_h

#include <iosfwd>

namespace SoftTrac {


//----------------------------------------------------------------- 
// CLASS: Token
//----------------------------------------------------------------- 
class Token
{
public:
   Token() : theToken(BLANK) {}
   Token(char t) : theToken(t) {}

   char getToken()  const { return theToken; }
   void setToken (char t) { theToken = t; }

   void clear() { theToken = BLANK; }
   void mark()  { theToken = MARK;  }

   bool operator==(const Token& t) const;
   bool operator!=(const Token& t) const { return !(*this==t); }

   bool isBlank()     const { return theToken == BLANK; }
   bool isNotBlank()  const { return !isBlank();        }
   bool isMarked()    const { return theToken == MARK;  }
   bool isNotMarked() const { return !isMarked();       }

private:
   enum 
   {
      BLANK = ' ',
      MARK  = '.'
   };

   char theToken;
};


std::ostream& operator<<(std::ostream&, const Token&);


//----------------------------------------------------------------- 
// Token::operator==
//----------------------------------------------------------------- 
inline bool Token::operator==(const Token& t) const 
{ 
   return theToken==t.theToken; 
}


} // namespace SoftTrac


#endif
