//----------------------------------------------------------------- 
// FILE: TokenGenerator.cpp
//----------------------------------------------------------------- 

#include "tconfig.h"
#include <algorithm>
#include "TokenGenerator.h"
#include "Token.h"

namespace SoftTrac {

std::vector<Token*> TokenGenerator::theTokens;
Rand                TokenGenerator::theRandomizer;
   

//----------------------------------------------------------------- 
// TokenGenerator::next
//----------------------------------------------------------------- 
const Token* TokenGenerator::next(int numTokens)
{
   if (theTokens.size() == 0) initialize();

   unsigned int index = theRandomizer(numTokens);
   return theTokens[index];
}


//----------------------------------------------------------------- 
// TokenGenerator::initialize
//----------------------------------------------------------------- 
void TokenGenerator::initialize()
{
	/*
   theTokens.push_back( new Token((char)1) );
   theTokens.push_back( new Token((char)2) );
   theTokens.push_back( new Token((char)3) );
   theTokens.push_back( new Token((char)4) );
   theTokens.push_back( new Token((char)5) );
   theTokens.push_back( new Token((char)6) );
   theTokens.push_back( new Token((char)14) );
   theTokens.push_back( new Token((char)15) );
   theTokens.push_back( new Token((char)16) );
   theTokens.push_back( new Token((char)17) );
   theTokens.push_back( new Token((char)18) );
   theTokens.push_back( new Token((char)20) );
   theTokens.push_back( new Token((char)21) );
   theTokens.push_back( new Token((char)127) );
   theTokens.push_back( new Token((char)251) );
   theTokens.push_back( new Token((char)238) );
   theTokens.push_back( new Token((char)237) );
   theTokens.push_back( new Token((char)236) );
   theTokens.push_back( new Token((char)234) );
   theTokens.push_back( new Token((char)232) );
   theTokens.push_back( new Token((char)228) );
   theTokens.push_back( new Token((char)226) );
   theTokens.push_back( new Token((char)225) );
   theTokens.push_back( new Token((char)224) );
   */

   for (char c = 'A'; c <= 'Z'; ++c)
   {
      theTokens.push_back( new Token(c) );
   }

   std::random_shuffle(theTokens.begin(), theTokens.end());
}


/*
   theTokens.push_back( new Token((char)1) );
   theTokens.push_back( new Token((char)2) );
   theTokens.push_back( new Token((char)3) );
   theTokens.push_back( new Token((char)4) );
   theTokens.push_back( new Token((char)5) );
   theTokens.push_back( new Token((char)6) );
   theTokens.push_back( new Token((char)14) );
   theTokens.push_back( new Token((char)15) );
   theTokens.push_back( new Token((char)16) );
   theTokens.push_back( new Token((char)17) );
   theTokens.push_back( new Token((char)18) );
   theTokens.push_back( new Token((char)20) );
   theTokens.push_back( new Token((char)21) );
   theTokens.push_back( new Token((char)127) );
   theTokens.push_back( new Token((char)251) );
   theTokens.push_back( new Token((char)238) );
   theTokens.push_back( new Token((char)237) );
   theTokens.push_back( new Token((char)236) );
   theTokens.push_back( new Token((char)234) );
   theTokens.push_back( new Token((char)232) );
   theTokens.push_back( new Token((char)228) );
   theTokens.push_back( new Token((char)226) );
   theTokens.push_back( new Token((char)225) );
   theTokens.push_back( new Token((char)224) );
*/


} // namespace SoftTrac
