//----------------------------------------------------------------- 
// FILE: main.cpp
//----------------------------------------------------------------- 

#include "tconfig.h"
#include <algorithm>
#include <iostream>
#include <memory>
#include <stdexcept>
#include "Board.h"
#include "BoardIterator.h"
#include "functional.h"
#include "TokenGenerator.h"
#include "ComputerPlayer.h"
#include "HumanPlayer.h"

using namespace std;
using namespace SoftTrac;


//----------------------------------------------------------------- 
// main
//----------------------------------------------------------------- 
int main(int /*argc*/, char** /*argv*/)
{try
{
   Board board;

   const int NUM_PLAYERS = 2;
   Player* players[NUM_PLAYERS];
   players[0] = new ComputerPlayer(board);
   players[1] = new HumanPlayer(board);

   int currentPlayerNo = 1;
   
   while (!board.isFull())
   {
      cout << board << endl;

      Player* currentPlayer = players[currentPlayerNo];
      currentPlayer->nextMove();
      currentPlayerNo = ++currentPlayerNo % NUM_PLAYERS;
   }
   
   return 0;
}
catch(const std::exception& e)
{
   std::cerr << e.what() << std::endl;
   exit(1);
}
catch(...)
{
   std::cerr << "Unknown error" << std::endl;
   exit(1);
}}





/*
   int* tokens = new int[TokenGenerator::numTokens()];
   std::fill(tokens, tokens+TokenGenerator::numTokens(), 0);

   for (int i = 0; i < 1024; ++i)
   {
      const Token* t = TokenGenerator::next();
      unsigned int index = (int)t->getToken() - (int)'A';
      tokens[index] = tokens[index] + 1;
   }

   for (int j = 0; j < TokenGenerator::numTokens(); ++j)
   { 
      cout << tokens[j] << endl;
   }

   exit(1);
*/
/*
   for (int rowNo = 0; rowNo < board.size(); ++rowNo)
   {
      Row row(&board, rowNo);
      for (Row::iterator ri = row.begin(); ri != row.end(); ++ri)
      {
         (*ri)->setToken('R');
         cout << board << endl;
         char ch;
         cin >> ch;
         cout << endl;
      }
   }

   for (int colNo = 0; colNo < board.size(); ++colNo)
   {
      Col col(&board, colNo);
      for (Col::iterator ci = col.begin(); ci != col.end(); ++ci)
      {
         (*ci)->setToken('C');
         cout << board << endl;
         char ch;
         cin >> ch;
         cout << endl;
      }
   }

   for (int n = 0; n < board.numDiags(); ++n)
   {
      BackDiag diag(&board, n);
      for (BackDiag::iterator i = diag.begin(); i != diag.end(); ++i)
      {
         (*i)->setToken('D');
         cout << board << endl;
         char ch;
         cin >> ch;
         cout << endl;
      }
   }

   for (int n = 0; n < board.numDiags(); ++n)
   {
      FwdDiag diag(&board, n);
      for (FwdDiag::iterator i = diag.begin(); i != diag.end(); ++i)
      {
         (*i)->setToken('F');
         cout << board << endl;
         char ch;
         cin >> ch;
         cout << endl;
      }
   }
*/
/*
   board.putToken(Square(4,0), 'B');
   board.putToken(Square(5,1), 'B');
   board.putToken(Square(6,2), 'B');
   board.putToken(Square(7,3), 'B');
   board.putToken(Square(8,4), 'B');

   board.putToken(Square(0,4), 'C');
   board.putToken(Square(0,5), 'C');
   board.putToken(Square(0,6), 'C');
   board.putToken(Square(0,7), 'C');
   board.putToken(Square(0,8), 'C');

   board.putToken(Square(0,1), 'C');
   board.putToken(Square(1,1), 'C');
   board.putToken(Square(2,1), 'C');
   board.putToken(Square(3,1), 'C');
   board.putToken(Square(4,1), 'C');

   board.putToken(Square(5,3), 'L');
   board.putToken(Square(5,4), 'L');
   board.putToken(Square(5,5), 'L');
   board.putToken(Square(5,6), 'L');
   board.putToken(Square(5,7), 'L');

   board.putToken(Square(0,5), 'C');
   board.putToken(Square(1,0), 'C');
   board.putToken(Square(3,5), 'T');
   board.putToken(Square(3,7), 'H');
   board.putToken(Square(4,5), 'C');
   board.putToken(Square(6,6), 'T');
   board.putToken(Square(7,6), 'U');

   board.putToken(Square(4,4), 'F');
   board.putToken(Square(5,3), 'F');
   board.putToken(Square(6,2), 'F');
   board.putToken(Square(7,1), 'F');
   board.putToken(Square(8,0), 'F');

*/

