//-----------------------------------------------------------------------------
// FILE:              Trace.cpp
//
//    Copyright (C)  2000 SoftTrac Corporation. All rights reserved.
//-----------------------------------------------------------------------------
// %W% %G%

#include "tconfig.h"
#include "Trace.h"
#include <iomanip>

using namespace std;

namespace SoftTrac {


//-----------------------------------------------------------------------------
// Trace::setAll
//-----------------------------------------------------------------------------
void Trace::setAll() 
{
   setEnter();
   setExit();
   setDebug();
   setLog();
   setError();
   setUser();
}
 

//-----------------------------------------------------------------------------
// Trace::clearAll
//-----------------------------------------------------------------------------
void Trace::clearAll() 
{
   clearEnter();
   clearExit();
   clearDebug();
   clearLog();
   clearError();
   clearUser();
}


//-----------------------------------------------------------------------------
// Trace::output
//-----------------------------------------------------------------------------
void Trace::output(std::ostream&      out,
                   const std::string& type,
                   const std::string& method,
                   const std::string& message) 
{
   out << setw(5) << left << type << " - " << theClassName << "::" << method;
   if (!message.empty()) out << " -- " << message;
   out << endl;
}


} // namespace SoftTrac