package com.softtrac.util;

import java.util.*;
import java.io.*;

/**
 * Trace
 *
 *
 * Created: Fri Sep 22 11:25:32 2000
 *
 * @author 
 * @version
 */

public class Trace {

   public Trace(String className) { theClassName = className; }
   
   public void enter(String method) {
      //>
      if (theEnterFlag) output(System.out, "Enter", method, "");
      //<
   }
   public void exit(String method) {
      //>
      if (theExitFlag) output(System.out, "Exit", method, "");
      //<
   }
   public void debug(String method, String message) {
      //>
      if (theDebugFlag) output(System.err, "Debug", method, message);
      //<
   }
   public void log(String method, String message) {
      //>
      if (theLogFlag) output(System.out, "Log", method, message);
      //<
   }
   public void error(String method, String message) {
      //>
      if (theErrorFlag) output(System.err, "Error", method, message);
      //<
   }
   public void user(String method, String message) {
      //>
      if (theUserFlag) output(System.out, "User", method, message);
      //<
   }
   public void setAll() {
      //>
      setEnter();
      setExit();
      setDebug();
      setLog();
      setError();
      setUser();
      //<
   }
   public void setEnter() { theEnterFlag = true; }
   public void setExit()  { theExitFlag  = true; }
   public void setDebug() { theDebugFlag = true; }
   public void setLog()   { theLogFlag   = true; }
   public void setError() { theErrorFlag = true; }
   public void setUser()  { theUserFlag  = true; }

   public void clearAll() {
      //>
      clearEnter();
      clearExit();
      clearDebug();
      clearLog();
      clearError();
      clearUser();
      //<
   }
   public void clearEnter() { theEnterFlag = false; }
   public void clearExit()  { theExitFlag  = false; }
   public void clearDebug() { theDebugFlag = false; }
   public void clearLog()   { theLogFlag   = false; }
   public void clearError() { theErrorFlag = false; }
   public void clearUser()  { theUserFlag  = false; }

   public class Exception extends java.lang.Exception {
      public Exception(String message) {
         //>
         super(message);
         //<
      }
   }
   public class UnknownFlag extends Trace.Exception {
      public UnknownFlag(String flag) {
         //>
         super(flag);
         //<
      }
   }
   private void output(PrintStream out,
                       String      type,
                       String      method,
                       String      message) {
      //>
      if (!message.equals("")) message = " - " + message;
      out.println(type + ": " + theClassName + "." + method + message);
      //<
   }
   private String  theClassName;
   private boolean theEnterFlag;
   private boolean theExitFlag;
   private boolean theDebugFlag;
   private boolean theLogFlag;   
   private boolean theErrorFlag;
   private boolean theUserFlag;
}











