//*****************************************************************************
// FILE:		HyperCube.h
//*****************************************************************************
#ifndef _UTIL_HYPERCUBE_H
#define _UTIL_HYPERCUBE_H


//*****************************************************************************
// CLASS:  HyperCube
//*****************************************************************************
template <class PT, class VT>
class HyperCube
{
public:
   int dimension() const { return theStart.dimension(); }

   const PT& start() const { return theStart; }
   PT&       start()       { return theStart; }

   const PT& stop() const  { return theStop; }
   PT&       stop()        { return theStop; }

   VT size() const { return theStop-theStart; }

protected:
   HyperCube(){}
   HyperCube(const PT& st, const PT& sp) : theStart(st), theStop(sp) {}
   HyperCube(const PT& st, const VT& sz) : theStart(st), theStop(st+sz) {}

private:
   PT theStart;
   PT theStop;
};


#endif
