//---------------------------------------------------------------------------
// FILE:  VectorNd.h
//---------------------------------------------------------------------------
#ifndef VectorNd_H
#define VectorNd_H

#include "points/VectorT.h"


//---------------------------------------------------------------------------
// CLASS:  VectorNd
//---------------------------------------------------------------------------
template <class T, int DIM>
class VectorNd : public VectorT<VectorNd<T,DIM>,T,DIM>
{
public:
	typedef VectorT<VectorNd<T,DIM>,T,DIM> VectorNdBase;

	VectorNd(const T& initialValue=0);

	VectorNd(const_iterator first, const_iterator last)
    : VectorNdBase(first, last) {}
};


template <class T, int DIM>
VectorNd<T,DIM>::VectorNd(const T& initialValue)
{
   for (int i = 0; i < DIM; ++i) at(i) = initialValue;
}


#endif

