//-----------------------------------------------------------------------------
// FILE:              XyVector.h
//
//    Copyright (C)  2001 SoftTrac Corporation. All rights reserved.
//-----------------------------------------------------------------------------
// %W% %G%
#ifndef SoftTrac_XyVector_H
#define SoftTrac_XyVector_H

#include <math.h>
#include "VectorT.h"

namespace SoftTrac {


//-----------------------------------------------------------------------------
// CLASS:  XyVector
//-----------------------------------------------------------------------------
template <class T>
class XyVector : public VectorT<XyVector<T>,T,2>
{
public:
   XyVector(){}
   XyVector(const VectorT<XyVector<T>,T,2>& vt):VectorT<XyVector<T>,T,2>(vt){}
   XyVector(const T& x, const T& y) : VectorT<XyVector<T>,T,2>(x, y) {}

   const T& x() const { return at(0); }
   T&       x()       { return at(0); }

   const T& y() const { return at(1); }
   T&       y()       { return at(1); }

   double distanceTo(const XyVector& v) const
   { return hypot(y()-v.y(), x()-v.x()); }
	
   bool operator==(const XyVector<T>& pt) const 
   {
      return (x()==pt.x()) ? (y()==pt.y()) ? true 
                                           : false 
                           : false;
   }

   bool operator<(const XyVector<T>& pt) const 
   {
      return (y()<pt.y()) ? true
                          : (y()==pt.y()) ? (x()<pt.x())
                                          : false;
   }
};


} // namespace SoftTrac


#endif

