//-----------------------------------------------------------------------------
// FILE:              Filename.h
//
//    Copyright (C)  2000 SoftTrac Corporation. All rights reserved.
//-----------------------------------------------------------------------------
// %W% %G%
#ifndef SoftTrac_Filename_H
#define SoftTrac_Filename_H

#include <string>
#include "util/util_api.h"

namespace SoftTrac {

typedef std::string FilenameBase;

//---------------------------------------------------------------------------
// CLASS:  Filename
//---------------------------------------------------------------------------
class SOFTTRAC_UTIL_API Filename : public FilenameBase
{
public:
   Filename() 
      : theBaseName(0) {}
   Filename(const char* s) 
      : FilenameBase(s), theBaseName(0) {}
   Filename(const std::string& str) 
      : FilenameBase(str), theBaseName(0) {}
   Filename(const Filename& fn, int pos=0, int n=std::string::npos)
      : FilenameBase(fn,pos,n), theBaseName(0) {}
   Filename(int n, char c) 
      : FilenameBase(n,c), theBaseName(0) {}

   virtual ~Filename(); 

   uint size() const;
   bool exists() const;

   const Filename& baseName() const;

private:
   mutable Filename* theBaseName;
};

} // namespace SoftTrac


#endif
