//-----------------------------------------------------------------------------
// NAME: Timothy R. Culp
// FILE: talgorithm.h
//-----------------------------------------------------------------------------
#ifndef talgorithmH
#define talgorithmH

#include <iosfwd>


namespace SoftTrac {

//-----------------------------------------------------------------------------
// forEach
//-----------------------------------------------------------------------------
template <class OutputIterator, class InputIterator, class BinaryFunction>
void forEach(OutputIterator ofirst,
             OutputIterator olast,
             InputIterator  ifirst,
             BinaryFunction fx)
{
	while (ofirst != olast) fx(*ofirst++, *ifirst++);
}


//-----------------------------------------------------------------------------
// print_elements()
//-----------------------------------------------------------------------------
template <class InputIterator>
std::ostream& print_elements(InputIterator first,
                             InputIterator last,
                             std::ostream& os,
                             char          start='(',
                             char          delimiter=',',
                             char          stop=')')
{
   os << start;

   while (first != last)
   {
      os << *first++;
      if (first != last) os << delimiter;
   }

   return os << stop;
}

} // namespace SoftTrac


#endif
