//-----------------------------------------------------------------------------
// NAME: Timothy R. Culp
// FILE: tfunctional.cpp
//-----------------------------------------------------------------------------

#include "tconfig.h"
#include <memory>
#include <cstdlib>
#include "util/os/OsTime.h"
#include "util/tfunctional.h"

using trac::Rand;

bool Rand::isSeeded = false;


//-----------------------------------------------------------------------------
// Rand::Rand
//-----------------------------------------------------------------------------
Rand::Rand()
{
   using trac::OsTime;
   std::auto_ptr<OsTime> os(OsTime::newTime());

   if (!isSeeded)
   {
      srand(os->time());
      isSeeded = true;
   }
}


//-----------------------------------------------------------------------------
// Rand::operator()
//-----------------------------------------------------------------------------
ulong Rand::operator()(ulong n)
{
   return rand() % n;
}

